﻿using System;
using System.Collections.Generic;
using System.Configuration;
using System.Data;
using System.Linq;
using System.Windows;
using Infragistics.Windows;
using Infragistics.Windows.DataPresenter;
using System.Collections.ObjectModel;
using Infragistics.DragDrop;
using System.Windows.Media;

namespace DragDropRecordsBetweenGrids
{
    /// <summary>
    /// Interaction logic for App.xaml
    /// </summary>
    public partial class App : Application
    {

        private void DragSource_Drop(object sender, Infragistics.DragDrop.DropEventArgs e)
        {
            if (e.OperationType == OperationType.DropNotAllowed)
                return;

            DataRecord dragRecord = (Utilities.GetAncestorFromType(e.DragSource, typeof(DataRecordPresenter), false) as DataRecordPresenter).Record as DataRecord;
            DataRecord dropRecord = (Utilities.GetAncestorFromType(e.DropTarget, typeof(DataRecordPresenter), false) as DataRecordPresenter).Record as DataRecord;

            if (dragRecord.DataPresenter != dropRecord.DataPresenter)
            {
                int insertIndex = dropRecord.DataItemIndex;
                (dropRecord.DataPresenter.DataSource as ObservableCollection<Emp>).Insert(insertIndex, dropRecord.DataItem as Emp);
            }
        }

        private void DragSource_DragEnter(object sender, DragDropCancelEventArgs e)
        {
            DataRecord dragRecord = (Utilities.GetAncestorFromType(e.DragSource, typeof(DataRecordPresenter), false) as DataRecordPresenter).Record as DataRecord;
            DataRecord dropRecord = (Utilities.GetAncestorFromType(e.DropTarget, typeof(DataRecordPresenter), false) as DataRecordPresenter).Record as DataRecord;

            if (dragRecord.DataPresenter != dropRecord.DataPresenter)
            {
                Emp dragData = dragRecord.DataItem as Emp;
                Emp dropData = dropRecord.DataItem as Emp;

                if (!dropData.Gender.Equals(dragData.Gender))
                {
                    e.OperationType = OperationType.DropNotAllowed;
                    DragDropManager.GetDropTarget(e.DropTarget).DropTargetMarkerBrush = Brushes.Red;
                }
                else
                {
                    e.OperationType = OperationType.Copy;
                    DragDropManager.GetDropTarget(e.DropTarget).DropTargetMarkerBrush = Brushes.Green;
                }
            }
        }
    }
}
